;
; make divergence of vector field
;
FUNCTION make_wdiv, file_name, ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2, ZMTYP = zmtyp, ALL_DATA = all_data

@common
@com_eg
;
   IF debug_w THEN print, '   ENTER make_wdiv... '

   var_name1 =  (strsplit(macro_base_fld, ',', ESCAPE = ' ', /EXTRACT))[0]
   var_name2 =  (strsplit(macro_base_fld, ',', ESCAPE = ' ', /EXTRACT))[1]

;  Build file_name2 if different

   IF strpos (cmd1_back.grid, '#') NE -1 THEN BEGIN 
      varpos = strpos(file_name,  var_name1)
      file_name2= strmid(file_name, 0, varpos)+var_name2+'.nc'
      IF debug_w THEN print, '   file_name2 = ', file_name2
   ENDIF ELSE file_name2 = file_name

;
;  Read the variables in the correspondent netcdf file
   var_x =  nc_read(file_name, var_name1,  ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2)
   var_y =  nc_read(file_name2, var_name2,  ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2)

; TO DO: ORCA grid C case
;   vargrid = 'U'
;   new_file = new_filename(file_name, 'T', vargrid)
;   taux = nc_read(new_file,'sozotaux', ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data)
;   vargrid = 'V'
;   new_file = new_filename(file_name, 'T', vargrid)
;   tauy = nc_read(new_file,'sometauy', ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data)

;   for ORCA C grid wdiv = div(var_x, var_y)

   grille,mask,glam,gphi,gdep,nx,ny,nz,premierx,premiery,premierz,dernierx,derniery,dernierz 
   wdiv =  (var_x.data - shift(var_x.data, -1, 0))/e1t[premierx:dernierx, premiery:derniery] + (var_y.data-shift(var_y.data, 0, -1))/e2t[premierx:dernierx, premiery:derniery]

   field = {name: '', data: wdiv, legend: '', units: '', origin: '', dim: 0, direc:''}
   
   field.origin = var_x.origin
   field.dim = var_x.dim
   field.direc = var_x.direc

   return, field
END 
